"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_charts_1 = require("@patternfly/react-charts");
var ResponsiveContainer_1 = __importDefault(require("../Common/ResponsiveContainer"));
var getLegendProps_1 = require("../Common/getLegendProps");
var helpers_1 = require("../Common/helpers");
var CreatePieChart = function (_a) {
    var _b, _c;
    var id = _a.id, schema = _a.schema, dataState = _a.dataState;
    var wrapper = schema.find(function (_a) {
        var i = _a.id;
        return i === id;
    });
    var data = dataState[0];
    var _d = (0, react_1.useState)(0), width = _d[0], setWidth = _d[1];
    var _e = (0, react_1.useState)([
        { hidden: true }
    ]), serie = _e[0], setSerie = _e[1];
    (0, react_1.useEffect)(function () {
        if (data.series.length > 0) {
            setSerie(data.series[0].serie.map(function (el) { return (__assign(__assign({}, el), { hidden: false })); }));
        }
    }, [data]);
    var props = __assign(__assign({ height: 300, y: 'y' }, wrapper === null || wrapper === void 0 ? void 0 : wrapper.props), ((_b = wrapper === null || wrapper === void 0 ? void 0 : wrapper.props) === null || _b === void 0 ? void 0 : _b.padding)
        ? { padding: (0, helpers_1.paddingNumberToObject)(wrapper.props.padding) }
        : {
            padding: {
                bottom: 70,
                left: 70,
                right: 50,
                top: 50
            }
        });
    var legendProps = (0, getLegendProps_1.getLegendProps)(wrapper, data, props.padding);
    if ((_c = wrapper.legend) === null || _c === void 0 ? void 0 : _c.interactive) {
        legendProps = __assign(__assign({}, legendProps), { legendComponent: (0, getLegendProps_1.getInteractiveLegendForSingleSeries)(wrapper, serie, setSerie, data) });
        delete legendProps.legendData;
    }
    return (react_1.default.createElement(ResponsiveContainer_1.default, { setWidth: setWidth, height: props.height }, data.series.length > 0 && react_1.default.createElement(react_charts_1.ChartPie, __assign({ constrainToVisibleArea: true }, props, legendProps, { data: serie.map(function (el) {
            var _a;
            return el.hidden
                ? (__assign(__assign({}, el), (_a = {}, _a[props.y] = 0, _a)))
                : (__assign({}, el));
        }), key: data.series[0].name, name: data.series[0].name, width: width }))));
};
exports.default = CreatePieChart;
//# sourceMappingURL=CreatePieChart.js.map