"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var types_1 = require("./types");
var CreateWrapper_1 = __importDefault(require("./Renderers/CreateWrapper"));
var CreatePieChart_1 = __importDefault(require("./Renderers/CreatePieChart"));
var stylePreprocess_1 = require("./Common/stylePreprocess");
var ChartRenderer = function (props) {
    var _a, _b;
    var schema = (0, stylePreprocess_1.replaceStringsWithFunctions)(props.schema, (_b = (_a = props.functions) === null || _a === void 0 ? void 0 : _a.style) !== null && _b !== void 0 ? _b : {});
    var newProps = __assign(__assign({}, props), { schema: schema });
    var chart = schema.find(function (_a) {
        var kind = _a.kind, parent = _a.parent;
        return kind === types_1.ChartKind.wrapper && parent === null;
    });
    if (chart.type === types_1.ChartTopLevelType.chart) {
        return (react_1.default.createElement(CreateWrapper_1.default, __assign({ key: chart.id + Math.random(), id: chart.id }, newProps)));
    }
    else if (chart.type === types_1.ChartTopLevelType.pie) {
        return (react_1.default.createElement(CreatePieChart_1.default, __assign({ key: chart.id + Math.random(), id: chart.id }, newProps)));
    }
    else {
        return null;
    }
};
exports.default = ChartRenderer;
//# sourceMappingURL=index.js.map