var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { ChartKind, ChartTopLevelType } from './types';
import CreateWrapper from './Renderers/CreateWrapper';
import CreatePieChart from './Renderers/CreatePieChart';
import { replaceStringsWithFunctions } from './Common/stylePreprocess';
var ChartRenderer = function (props) {
    var _a, _b;
    var schema = replaceStringsWithFunctions(props.schema, (_b = (_a = props.functions) === null || _a === void 0 ? void 0 : _a.style) !== null && _b !== void 0 ? _b : {});
    var newProps = __assign(__assign({}, props), { schema: schema });
    var chart = schema.find(function (_a) {
        var kind = _a.kind, parent = _a.parent;
        return kind === ChartKind.wrapper && parent === null;
    });
    if (chart.type === ChartTopLevelType.chart) {
        return (React.createElement(CreateWrapper, __assign({ key: chart.id + Math.random(), id: chart.id }, newProps)));
    }
    else if (chart.type === ChartTopLevelType.pie) {
        return (React.createElement(CreatePieChart, __assign({ key: chart.id + Math.random(), id: chart.id }, newProps)));
    }
    else {
        return null;
    }
};
export default ChartRenderer;
//# sourceMappingURL=index.js.map